//******************************************************************************
//* uSBSS version 3.5
//* Module revision: 2017.07.07
//* www.rusbss.ru
//******************************************************************************
//*    ussReader.dll   
//*    ussReaderRun.pas
//******************************************************************************

{$I ussReader.inc}

unit ussReaderIntf;

interface

uses
  Variants, Classes, Graphics,
{$IFDEF USEADODATASET}
  ADODB,
{$ENDIF}
{$IFDEF USECLIENTDATASET}
  DbClient,
{$ENDIF}
  Dialogs,
  ussReaderTypes;

function ussReader_GetVersion: Double; StdCall;
//   

procedure ussReader_SetLanguage(ALng: Integer); StdCall;
//   
// English = 1033 ($409)
// Russian = 1049 ($419)

function ussReader_InterceptCheck: Boolean; StdCall;
//      mssdiz.dll
//  ,  C:\USBSS\mssdiz.dll
//  

procedure ussReader_Init(AAddLogMethod: TAddLogMethodW); StdCall;
procedure ussReader_InitEx(AAppHandle: LongWord;
  AAddLogMethod: TAddLogMethodW;
  AShowErrorMethod: TShowErrorMethodW); StdCall;
//       ussServer

procedure ussReader_Done; StdCall;
//       ussServer

procedure ussReader_SetTunesFile(const AFileName: WideString); StdCall;
// if AFileName = '' then ussReader.opt else AFileName.opt

procedure ussReader_ClearTunes; StdCall;
//  

procedure ussReader_SetTunes(const AData: TUSSReaderDataTunes); StdCall;
//  

procedure ussReader_GetTunes(var AData: TUSSReaderDataTunes); StdCall;
//   

procedure ussReader_ReadTunes; StdCall;
//     ussReader.opt
//   ,  

procedure ussReader_WriteTunes; StdCall;
//     ussReader.opt
//   ,  

procedure ussReader_DialogTunes(const ACaption: WideString; ADoRasHangup: Boolean); StdCall;
//     
//    ussServer
//   
//   OK,     ussReader.opt
//   ,  

function ussReader_OpenConnection(const AGroupName: WideString): WideString; StdCall;
//    ussServer
//         AGroupName
//  SQL-   SSDATAREADER  
//  OK,       
//   OK,    

function ussReader_OpenConnectionEx(var AResult: WideString;
  const AGroupName, AUserName: WideString): Boolean; StdCall;
//    ussServer
//         AGroupName
//  AUserName <> ''  SQL-   AUserName  
//  AUserName = ''  SQL-  
//  OK,  AResult      
//   OK,  AResult   

procedure ussReader_CloseConnection(ADoRasHangup: Boolean); StdCall;
//     
//    ussServer

function ussReader_GetDataADODataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean; StdCall;
//   ACommandText
//     AData
//  AFormat = 0 AData    ADO Stream
//  AFormat = 1 AData   ADO XML
//     ussReader_LoadADODataSet

function ussReader_GetDataClientDataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean; StdCall;
//   ACommandText
//     AData
//  AFormat = 0 AData    ClientDataSet
//  AFormat = 1 AData   ClientDataSet XML
//     ussReader_LoadClientDataSet

//------------------------------------------------------------------------------

{$IFDEF USEADODATASET}
function ussReader_LoadADODataSet(ADataSet: TCustomADODataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;
//  brief-case ADataSet
//  AFormat = 0   
//  AFormat = 1   XML
{$ENDIF}

{$IFDEF USECLIENTDATASET}
function ussReader_LoadClientDataSet(ADataSet: TClientDataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;
//  brief-case ADataSet
//  AFormat = 0   
//  AFormat = 1   XML
{$ENDIF}

implementation

{$IFDEF USEADODATASET}
function ussReader_LoadADODataSet(ADataSet: TCustomADODataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;

  procedure ADODataSetSetData(ADataSet: TCustomADODataSet;
    AFormat: Integer;
    var AData: OleVariant);
  var
    Format: ADODB.TPersistFormat;
  begin
    case AFormat of
      0: Format := pfADTG;
    else
      Format := pfXML;
    end;
    ADODataSetFromRawData(ADataSet, AData, Format);
    AData := VARIANTS.Null;
  end;

var
  Data: OleVariant;
begin
  Result := False;
  if ussReader_GetDataADODataSet(ACommandText, AFormat, Data) then
  begin
    ADODataSetSetData(ADataSet, AFormat, Data);
    Result := True;
  end;
end;
{$ENDIF}

{$IFDEF USECLIENTDATASET}
function ussReader_LoadClientDataSet(ADataSet: TClientDataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;

  procedure ClientDataSetSetData(ADataSet: TClientDataSet;
    AFormat: Integer;
    var AData: OleVariant);
  begin
    case AFormat of
      0: ADataSet.Data := AData;
    else
      ADataSet.XMLData := AData;
    end;
    AData := VARIANTS.Null;
  end;

var
  Data: OleVariant;
begin
  Result := False;
  if ussReader_GetDataClientDataSet(ACommandText, AFormat, Data) then
  begin
    ClientDataSetSetData(ADataSet, AFormat, Data);
    Result := True;
  end;
end;
{$ENDIF}

//------------------------------------------------------------------------------

function ussReader_GetVersion;
external ussReaderDLL name 'ussReader_GetVersion';

procedure ussReader_SetLanguage;
external ussReaderDLL name 'ussReader_SetLanguage';

function ussReader_InterceptCheck;
external ussReaderDLL name 'ussReader_InterceptCheck';

procedure ussReader_Init;
external ussReaderDLL name 'ussReader_Init';

procedure ussReader_InitEx;
external ussReaderDLL name 'ussReader_InitEx';

procedure ussReader_Done;
external ussReaderDLL name 'ussReader_Done';

procedure ussReader_SetTunesFile;
external ussReaderDLL name 'ussReader_SetTunesFile';

procedure ussReader_ClearTunes;
external ussReaderDLL name 'ussReader_ClearTunes';

procedure ussReader_SetTunes;
external ussReaderDLL name 'ussReader_SetTunes';

procedure ussReader_GetTunes;
external ussReaderDLL name 'ussReader_GetTunes';

procedure ussReader_ReadTunes;
external ussReaderDLL name 'ussReader_ReadTunes';

procedure ussReader_WriteTunes;
external ussReaderDLL name 'ussReader_WriteTunes';

procedure ussReader_DialogTunes;
external ussReaderDLL name 'ussReader_DialogTunes';

function ussReader_OpenConnection;
external ussReaderDLL name 'ussReader_OpenConnection';

function ussReader_OpenConnectionEx;
external ussReaderDLL name 'ussReader_OpenConnectionEx';

procedure ussReader_CloseConnection;
external ussReaderDLL name 'ussReader_CloseConnection';

function ussReader_GetDataADODataSet;
external ussReaderDLL name 'ussReader_GetDataADODataSet';

function ussReader_GetDataClientDataSet;
external ussReaderDLL name 'ussReader_GetDataClientDataSet';

end.

