//******************************************************************************
//* uSBSS version 3.5
//* Module revision: 2017.07.07
//* www.rusbss.ru
//******************************************************************************
//*    ussReader.dll   
//*    ussReaderIntf.pas
//******************************************************************************

{$I ussReader.inc}

unit ussReaderRun;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics,
{$IFDEF USEADODATASET}
  ADODB,
{$ENDIF}
{$IFDEF USECLIENTDATASET}
  DbClient,
{$ENDIF}
  Dialogs,
  ussReaderTypes;

function ussReader_GetVersion: Double;
//   

procedure ussReader_SetLanguage(ALng: Integer);
//   
// English = 1033 ($409)
// Russian = 1049 ($419)

function ussReader_InterceptCheck: Boolean;
//      mssdiz.dll
//  ,  C:\USBSS\mssdiz.dll
//  

procedure ussReader_Init(AAddLogMethod: TAddLogMethodW);
procedure ussReader_InitEx(AAppHandle: LongWord;
  AAddLogMethod: TAddLogMethodW;
  AShowErrorMethod: TShowErrorMethodW);
//       ussServer

procedure ussReader_Done;
//       ussServer

procedure ussReader_SetTunesFile(const AFileName: WideString);
// if AFileName = '' then ussReader.opt else AFileName.opt

procedure ussReader_ClearTunes;
//  

procedure ussReader_SetTunes(const AData: TUSSReaderDataTunes);
//  

procedure ussReader_GetTunes(var AData: TUSSReaderDataTunes);
//   

procedure ussReader_ReadTunes;
//     ussReader.opt
//   ,  

procedure ussReader_WriteTunes;
//     ussReader.opt
//   ,  

procedure ussReader_DialogTunes(const ACaption: WideString; ADoRasHangup: Boolean);
//     
//    ussServer
//   
//   OK,     ussReader.opt
//   ,  

function ussReader_OpenConnection(const AGroupName: WideString): WideString;
//    ussServer
//         AGroupName
//  SQL-   SSDATAREADER  
//  OK,       
//   OK,    

function ussReader_OpenConnectionEx(var AResult: WideString;
  const AGroupName, AUserName: WideString): Boolean;
//    ussServer
//         AGroupName
//  AUserName <> ''  SQL-   AUserName  
//  AUserName = ''  SQL-  
//  OK,  AResult      
//   OK,  AResult   

procedure ussReader_CloseConnection(ADoRasHangup: Boolean);
//     
//    ussServer

function ussReader_GetDataADODataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean;
//   ACommandText
//     AData
//  AFormat = 0 AData    ADO Stream
//  AFormat = 1 AData   ADO XML
//     ussReader_LoadADODataSet

function ussReader_GetDataClientDataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean;
//   ACommandText
//     AData
//  AFormat = 0 AData    ClientDataSet
//  AFormat = 1 AData   ClientDataSet XML
//     ussReader_LoadClientDataSet

//------------------------------------------------------------------------------

{$IFDEF USEADODATASET}
function ussReader_LoadADODataSet(ADataSet: TCustomADODataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;
//  brief-case ADataSet
//  AFormat = 0   
//  AFormat = 1   XML
{$ENDIF}

{$IFDEF USECLIENTDATASET}
function ussReader_LoadClientDataSet(ADataSet: TClientDataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;
//  brief-case ADataSet
//  AFormat = 0   
//  AFormat = 1   XML
{$ENDIF}

//------------------------------------------------------------------------------

procedure ussReader_LoadDLL;
procedure ussReader_UnloadDLL;

implementation

type
  TussReader_GetVersion = function: Double; StdCall;

  TussReader_SetLanguage = procedure(ALng: Integer); StdCall;

  TussReader_InterceptCheck = function: Boolean; StdCall;

  TussReader_Init = procedure(AAddLogMethod: TAddLogMethodW); StdCall;

  TussReader_InitEx = procedure(AAppHandle: LongWord;
    AAddLogMethod: TAddLogMethodW;
    AShowErrorMethod: TShowErrorMethodW); StdCall;

  TussReader_Done = procedure; StdCall;

  TussReader_SetTunesFile = procedure(const AFileName: WideString); StdCall;

  TussReader_ClearTunes = procedure; StdCall;

  TussReader_SetTunes = procedure(const AData: TUSSReaderDataTunes); StdCall;

  TussReader_GetTunes = procedure(var AData: TUSSReaderDataTunes); StdCall;

  TussReader_ReadTunes = procedure; StdCall;

  TussReader_WriteTunes = procedure; StdCall;

  TussReader_DialogTunes = procedure(const ACaption: WideString; ADoRasHangup: Boolean); StdCall;

  TussReader_OpenConnection = function(const AGroupName: WideString): WideString; StdCall;

  TussReader_OpenConnectionEx = function(var AResult: WideString;
    const AGroupName, AUserName: WideString): Boolean; StdCall;

  TussReader_CloseConnection = procedure(ADoRasHangup: Boolean); StdCall;

  TussReader_GetDataADODataSet = function(const ACommandText: WideString;
    AFormat: Integer;
    var AData: OleVariant): Boolean; StdCall;

  TussReader_GetDataClientDataSet = function(const ACommandText: WideString;
    AFormat: Integer;
    var AData: OleVariant): Boolean; StdCall;

var
  ussReader_GetVersionFunc: TussReader_GetVersion = nil;
  ussReader_SetLanguageProc: TussReader_SetLanguage = nil;
  ussReader_InterceptCheckFunc: TussReader_InterceptCheck = nil;
  ussReader_InitProc: TussReader_Init = nil;
  ussReader_InitExProc: TussReader_InitEx = nil;
  ussReader_DoneProc: TussReader_Done = nil;
  ussReader_SetTunesFileProc: TussReader_SetTunesFile = nil;
  ussReader_ClearTunesProc: TussReader_ClearTunes = nil;
  ussReader_SetTunesProc: TussReader_SetTunes = nil;
  ussReader_GetTunesProc: TussReader_GetTunes = nil;
  ussReader_ReadTunesProc: TussReader_ReadTunes = nil;
  ussReader_WriteTunesProc: TussReader_WriteTunes = nil;
  ussReader_DialogTunesProc: TussReader_DialogTunes = nil;
  ussReader_OpenConnectionFunc: TussReader_OpenConnection = nil;
  ussReader_OpenConnectionExFunc: TussReader_OpenConnectionEx = nil;
  ussReader_CloseConnectionProc: TussReader_CloseConnection = nil;
  ussReader_GetDataADODataSetFunc: TussReader_GetDataADODataSet = nil;
  ussReader_GetDataClientDataSetFunc: TussReader_GetDataClientDataSet = nil;

  ussReaderModule: THandle = 0;
  ussReaderVersion: Double = 0.0;

procedure NotSupportedError(const AProcName: string);
var
  FFormatSettings: TFormatSettings;
  S: string;
begin
  GetLocaleFormatSettings(GetThreadLocale, FFormatSettings);
  FFormatSettings.DecimalSeparator := '.';
  S := FloatToStr(ussReaderVersion, FFormatSettings);
  raise Exception.CreateFmt('%s     %s', [AProcName, S]);
end;

procedure ussReader_LoadDLL;

  function GetAddress(AProcName: PChar): Pointer;
  begin
    Result := GetProcAddress(ussReaderModule, AProcName);
    if Result = nil then
      raise Exception.CreateFmt('   %s', [AProcName]);
  end;

begin
  if (ussReaderModule = 0) then
  begin
    ussReaderModule := LoadLibrary(PChar(ussReaderDLL));
    if ussReaderModule = 0 then
      raise Exception.CreateFmt('   %s', [ussReaderDLL]);

    @ussReader_GetVersionFunc := GetAddress('ussReader_GetVersion');
    ussReaderVersion := ussReader_GetVersionFunc;

    @ussReader_SetLanguageProc := GetAddress('ussReader_SetLanguage');
    @ussReader_InterceptCheckFunc := GetAddress('ussReader_InterceptCheck');
    @ussReader_InitProc := GetAddress('ussReader_Init');
    @ussReader_DoneProc := GetAddress('ussReader_Done');
    @ussReader_ClearTunesProc := GetAddress('ussReader_ClearTunes');
    @ussReader_SetTunesProc := GetAddress('ussReader_SetTunes');
    @ussReader_GetTunesProc := GetAddress('ussReader_GetTunes');
    @ussReader_ReadTunesProc := GetAddress('ussReader_ReadTunes');
    @ussReader_WriteTunesProc := GetAddress('ussReader_WriteTunes');
    @ussReader_DialogTunesProc := GetAddress('ussReader_DialogTunes');
    @ussReader_OpenConnectionFunc := GetAddress('ussReader_OpenConnection');
    @ussReader_CloseConnectionProc := GetAddress('ussReader_CloseConnection');
    @ussReader_GetDataADODataSetFunc := GetAddress('ussReader_GetDataADODataSet');
    @ussReader_GetDataClientDataSetFunc := GetAddress('ussReader_GetDataClientDataSet');

    if (ussReaderVersion > 3.3) then
    begin
      @ussReader_InitExProc := GetAddress('ussReader_InitEx');
      @ussReader_SetTunesFileProc := GetAddress('ussReader_SetTunesFile');
      @ussReader_OpenConnectionExFunc := GetAddress('ussReader_OpenConnectionEx');
    end;
  end;
end;

procedure ussReader_UnloadDLL;
begin
  if (ussReaderModule <> 0) then
  begin
    FreeLibrary(ussReaderModule);
    ussReaderModule := 0;
    ussReaderVersion := 0.0;
  end;
end;

//------------------------------------------------------------------------------

function ussReader_GetVersion: Double;
begin
  ussReader_LoadDLL;
  Result := ussReader_GetVersionFunc;
end;

procedure ussReader_SetLanguage(ALng: Integer);
begin
  ussReader_LoadDLL;
  ussReader_SetLanguageProc(ALng);
end;

function ussReader_InterceptCheck: Boolean;
begin
  ussReader_LoadDLL;
  Result := ussReader_InterceptCheckFunc;
end;

procedure ussReader_Init(AAddLogMethod: TAddLogMethodW);
begin
  ussReader_LoadDLL;
  ussReader_InitProc(AAddLogMethod);
end;

procedure ussReader_InitEx(AAppHandle: LongWord;
  AAddLogMethod: TAddLogMethodW;
  AShowErrorMethod: TShowErrorMethodW);
begin
  ussReader_LoadDLL;
  if Assigned(ussReader_InitExProc) then
  begin
    ussReader_InitExProc(AAppHandle,
      AAddLogMethod,
      AShowErrorMethod);
  end
  else
  begin
    NotSupportedError('ussReader_InitEx');
  end;
end;

procedure ussReader_Done;
begin
  ussReader_LoadDLL;
  ussReader_DoneProc;
end;

procedure ussReader_SetTunesFile(const AFileName: WideString);
begin
  ussReader_LoadDLL;
  if Assigned(ussReader_SetTunesFileProc) then
  begin
    ussReader_SetTunesFileProc(AFileName);
  end
  else
  begin
    NotSupportedError('ussReader_SetTunesFile');
  end;
end;

procedure ussReader_ClearTunes;
begin
  ussReader_LoadDLL;
  ussReader_ClearTunesProc;
end;

procedure ussReader_SetTunes(const AData: TUSSReaderDataTunes);
begin
  ussReader_LoadDLL;
  ussReader_SetTunesProc(AData);
end;

procedure ussReader_GetTunes(var AData: TUSSReaderDataTunes);
begin
  ussReader_LoadDLL;
  ussReader_GetTunesProc(AData);
end;

procedure ussReader_ReadTunes;
begin
  ussReader_LoadDLL;
  ussReader_ReadTunesProc;
end;

procedure ussReader_WriteTunes;
begin
  ussReader_LoadDLL;
  ussReader_WriteTunesProc;
end;

procedure ussReader_DialogTunes(const ACaption: WideString; ADoRasHangup: Boolean);
begin
  ussReader_LoadDLL;
  ussReader_DialogTunesProc(ACaption, ADoRasHangup);
end;

function ussReader_OpenConnection(const AGroupName: WideString): WideString;
begin
  ussReader_LoadDLL;
  Result := ussReader_OpenConnectionFunc(AGroupName);
end;

function ussReader_OpenConnectionEx(var AResult: WideString;
  const AGroupName, AUserName: WideString): Boolean;
begin
  ussReader_LoadDLL;
  if Assigned(ussReader_OpenConnectionExFunc) then
  begin
    if ussReader_OpenConnectionExFunc(AResult, AGroupName, AUserName) then;
  end
  else
  begin
    NotSupportedError('ussReader_OpenConnectionEx');
  end;
end;

procedure ussReader_CloseConnection(ADoRasHangup: Boolean);
begin
  ussReader_LoadDLL;
  ussReader_CloseConnectionProc(ADoRasHangup);
end;

function ussReader_GetDataADODataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean;
begin
  ussReader_LoadDLL;
  Result := ussReader_GetDataADODataSetFunc(ACommandText,
    AFormat,
    AData);
end;

function ussReader_GetDataClientDataSet(const ACommandText: WideString;
  AFormat: Integer;
  var AData: OleVariant): Boolean;
begin
  ussReader_LoadDLL;
  Result := ussReader_GetDataClientDataSetFunc(ACommandText,
    AFormat,
    AData);
end;

//------------------------------------------------------------------------------

{$IFDEF USEADODATASET}
function ussReader_LoadADODataSet(ADataSet: TCustomADODataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;

  procedure ADODataSetSetData(ADataSet: TCustomADODataSet;
    AFormat: Integer;
    var AData: OleVariant);
  var
    Format: ADODB.TPersistFormat;
  begin
    case AFormat of
      0: Format := pfADTG;
    else
      Format := pfXML;
    end;
    ADODataSetFromRawData(ADataSet, AData, Format);
    AData := VARIANTS.Null;
  end;

var
  Data: OleVariant;
begin
  Result := False;
  if ussReader_GetDataADODataSet(ACommandText, AFormat, Data) then
  begin
    ADODataSetSetData(ADataSet, AFormat, Data);
    Result := True;
  end;
end;
{$ENDIF}

{$IFDEF USECLIENTDATASET}
function ussReader_LoadClientDataSet(ADataSet: TClientDataSet;
  const ACommandText: WideString;
  AFormat: Integer): Boolean;

  procedure ClientDataSetSetData(ADataSet: TClientDataSet;
    AFormat: Integer;
    var AData: OleVariant);
  begin
    case AFormat of
      0: ADataSet.Data := AData;
    else
      ADataSet.XMLData := AData;
    end;
    AData := VARIANTS.Null;
  end;

var
  Data: OleVariant;
begin
  Result := False;
  if ussReader_GetDataClientDataSet(ACommandText, AFormat, Data) then
  begin
    ClientDataSetSetData(ADataSet, AFormat, Data);
    Result := True;
  end;
end;
{$ENDIF}

initialization
finalization
  ussReader_UnloadDLL;
end.

